import GC from '@grapecity/spread-sheets';
import "@grapecity/spread-sheets-io";
import * as ExcelIO from "@grapecity/spread-excelio";
import { SpreadSheets, Worksheet, Column } from '@grapecity/spread-sheets-react';
import "@grapecity/spread-sheets/styles/gc.spread.sheets.css"
import './App.css';
import { useRef } from 'react';

function App() {
  let spreadref = useRef(new GC.Spread.Sheets.Workbook());
  function load() {
    const file = (document.getElementById("file") as any)?.files[0];

    if (!file) {
      console.log("file not found!!");
      return;
    }

    const spread = spreadref.current;

    const excelio = new ExcelIO.IO();

    // excelio.open(file, function (json: any) {
    //   var workbookObj = json;
    //   spread.fromJSON(workbookObj);
    //   const sheet = spread.getActiveSheet();
    //   sheet.setActiveCell(0, 0);
    //   sheet.options.protectionOptions.allowSelectLockedCells = false;
    //   sheet.options.isProtected = true;
    // }, function (e: any) {
    //   console.log(e);
    // });
    spread.import(file, () => {
      // var workbookObj = json;
      // spread.fromJSON(workbookObj);
      const sheet = spread.getActiveSheet();
      sheet.setActiveCell(0, 0);
      sheet.options.protectionOptions.allowSelectLockedCells = false;
      sheet.options.isProtected = true;
    }, (err: any) => {
      console.log(err)
    })
  }
  function initSpread(spread: GC.Spread.Sheets.Workbook) {
    spreadref.current = spread;
    const sheet = spread.getActiveSheet();

    // debugging
    (window as any)["GC"] = GC;
    (window as any)["spread"] = spread
  }
  return (
    <div className="sample-tutorial">
      <input type="file" id="file"></input>
      <button id="load" onClick={load}>load</button>
      <div className="sample-spreadsheets">
        <SpreadSheets workbookInitialized={spread => initSpread(spread)}>
          <Worksheet></Worksheet>
          <Worksheet></Worksheet>
          <Worksheet></Worksheet>
        </SpreadSheets>
        <div id="statusBar"></div>
      </div>
      <div className="options-container">
      </div>
    </div>
  )
}

export default App;
